import { Command } from 'substance'

class IsolatedNoteCommand extends Command {
  constructor () {
    super({ name: 'insert-isolated-note' })
  }

  getCommandState (params) {
    let sel = params.selection
    let newState = {
      disabled: !sel.isPropertySelection(),
      active: false
    }
    return newState
  }

  /**
    Insert new inline node at the current selection
  */
  execute (params) {
    let state = this.getCommandState(params)
    if (state.disabled) return
    let editorSession = this._getEditorSession(params)
    editorSession.transaction((tx) => {
      let nodeData = this.createNodeData(tx, params)
      console.log('nodeData', nodeData)
      tx.insertBlockNode(nodeData)
    })
  }

  createNodeData(tx) { // eslint-disable-line
    return {
      'type': 'isolated-note',
      'content': 'isolated note',
      'index': 1
    }
  }
}

export default IsolatedNoteCommand
